Index: docshell/base/nsDocShell.cpp
===================================================================
RCS file: /cvsroot/mozilla/docshell/base/nsDocShell.cpp,v
retrieving revision 1.833
diff -p -U 8 -r1.833 nsDocShell.cpp
--- docshell/base/nsDocShell.cpp	6 May 2007 21:06:27 -0000	1.833
+++ docshell/base/nsDocShell.cpp	14 May 2007 09:22:19 -0000
@@ -133,16 +133,17 @@
 #include "nsIHistoryEntry.h"
 #include "nsISHistoryListener.h"
 #include "nsIWindowWatcher.h"
 #include "nsIPromptFactory.h"
 #include "nsIObserver.h"
 #include "nsINestedURI.h"
 #include "nsITransportSecurityInfo.h"
 #include "nsINSSErrorsService.h"
+#include "nsICookieService.h"
 
 // Editor-related
 #include "nsIEditingSession.h"
 
 #include "nsPIDOMWindow.h"
 #include "nsIDOMDocument.h"
 #include "nsICachingChannel.h"
 #include "nsICacheVisitor.h"
@@ -295,17 +296,18 @@ nsDocShell::nsDocShell():
     mMarginWidth(0),
     mMarginHeight(0),
     mItemType(typeContent),
     mDefaultScrollbarPref(Scrollbar_Auto, Scrollbar_Auto),
     mPreviousTransIndex(-1),
     mLoadedTransIndex(-1),
     mEditorData(nsnull),
     mTreeOwner(nsnull),
-    mChromeEventHandler(nsnull)
+    mChromeEventHandler(nsnull),
+    mCookieContainer(nsnull)
 {
     if (gDocShellCount++ == 0) {
         NS_ASSERTION(sURIFixup == nsnull,
                      "Huh, sURIFixup not null in first nsDocShell ctor!");
 
         CallGetService(NS_URIFIXUP_CONTRACTID, &sURIFixup);
     }
 
@@ -361,16 +363,24 @@ nsDocShell::Init()
     nsCOMPtr<InterfaceRequestorProxy> proxy =
         new InterfaceRequestorProxy(NS_STATIC_CAST(nsIInterfaceRequestor*,
                                                    this));
     NS_ENSURE_TRUE(proxy, NS_ERROR_OUT_OF_MEMORY);
     mLoadGroup->SetNotificationCallbacks(proxy);
 
     rv = nsDocLoader::AddDocLoaderAsChildOfRoot(this);
     NS_ENSURE_SUCCESS(rv, rv);
+
+
+    // set to the default cookieContainer
+    nsCOMPtr<nsICookieService> csvc = do_GetService(NS_COOKIESERVICE_CONTRACTID);
+    nsCOMPtr<nsICookieContainer> container;
+    csvc->GetDefaultContainer(getter_AddRefs(container));
+    SetCookieContainer(container);
+
     
     // Add as |this| a progress listener to itself.  A little weird, but
     // simpler than reproducing all the listener-notification logic in
     // overrides of the various methods via which nsDocLoader can be
     // notified.   Note that this holds an nsWeakPtr to ourselves, so it's ok.
     return AddProgressListener(this, nsIWebProgress::NOTIFY_STATE_DOCUMENT |
                                      nsIWebProgress::NOTIFY_STATE_NETWORK);
     
@@ -414,16 +424,17 @@ NS_INTERFACE_MAP_BEGIN(nsDocShell)
     NS_INTERFACE_MAP_ENTRY(nsIRefreshURI)
     NS_INTERFACE_MAP_ENTRY(nsIWebProgressListener)
     NS_INTERFACE_MAP_ENTRY(nsISupportsWeakReference)
     NS_INTERFACE_MAP_ENTRY(nsIContentViewerContainer)
     NS_INTERFACE_MAP_ENTRY(nsIEditorDocShell)
     NS_INTERFACE_MAP_ENTRY(nsIWebPageDescriptor)
     NS_INTERFACE_MAP_ENTRY(nsIAuthPromptProvider)
     NS_INTERFACE_MAP_ENTRY(nsIObserver)
+    NS_INTERFACE_MAP_ENTRY(nsICookieCollector)
 NS_INTERFACE_MAP_END_INHERITING(nsDocLoader)
 
 ///*****************************************************************************
 // nsDocShell::nsIInterfaceRequestor
 //*****************************************************************************   
 NS_IMETHODIMP nsDocShell::GetInterface(const nsIID & aIID, void **aSink)
 {
     NS_PRECONDITION(aSink, "null out param");
@@ -1744,16 +1755,25 @@ nsDocShell::SetDocLoaderParent(nsDocLoad
             SetAllowSubframes(value);
         }
         if (NS_SUCCEEDED(parentAsDocShell->GetAllowImages(&value)))
         {
             SetAllowImages(value);
         }
     }
 
+    // if parent is nsICookieCollector, inherit cookie container
+    nsCOMPtr<nsICookieCollector> parentAsCookieCollector(do_QueryInterface(parent));
+    if (parentAsCookieCollector)
+    {
+        nsCOMPtr<nsICookieContainer> container;
+        if (NS_SUCCEEDED(parentAsCookieCollector->GetCookieContainer(getter_AddRefs(container))))
+            SetCookieContainer(container);
+    }
+
     nsCOMPtr<nsIURIContentListener> parentURIListener(do_GetInterface(parent));
     if (parentURIListener)
         mContentListener->SetParentContentListener(parentURIListener);
     return NS_OK;
 }
 
 NS_IMETHODIMP
 nsDocShell::GetSameTypeParent(nsIDocShellTreeItem ** aParent)
@@ -6896,16 +6916,22 @@ nsDocShell::DoURILoad(nsIURI * aURI,
     if (httpChannelInternal) {
       if (aFirstParty) {
         httpChannelInternal->SetDocumentURI(aURI);
       } else {
         httpChannelInternal->SetDocumentURI(aReferrerURI);
       }
     }
 
+    // set the http request cookie container to that of the parent docshell
+    nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(channel));
+    if (cookieCollector) {
+      cookieCollector->SetCookieContainer(mCookieContainer);
+    }
+
     nsCOMPtr<nsIWritablePropertyBag2> props(do_QueryInterface(channel));
     if (props)
     {
       // save true referrer for those who need it (e.g. xpinstall whitelisting)
       // Currently only http and ftp channels support this.
       props->SetPropertyAsInterface(NS_LITERAL_STRING("docshell.internalReferrer"),
                                     aReferrerURI);
     }
@@ -8906,9 +8932,30 @@ nsDocShell::IsAboutBlank(nsIURI* aURI)
     if (NS_FAILED(aURI->SchemeIs("about", &isAbout)) || !isAbout) {
         return PR_FALSE;
     }
     
     nsCAutoString str;
     aURI->GetSpec(str);
     return str.EqualsLiteral("about:blank");
 }
-                                     
+
+
+//*****************************************************************************
+// nsDocShell::nsICookieCollector
+//*****************************************************************************
+/* attribute nsICookieContainer cookieContainer; */
+NS_IMETHODIMP
+nsDocShell::GetCookieContainer(nsICookieContainer * *aCookieContainer)
+{
+    NS_ENSURE_ARG_POINTER(aCookieContainer);
+    *aCookieContainer = mCookieContainer;
+    NS_IF_ADDREF(*aCookieContainer);
+    return NS_OK;
+}
+NS_IMETHODIMP
+nsDocShell::SetCookieContainer(nsICookieContainer * aCookieContainer)
+{
+    mCookieContainer = aCookieContainer;
+    NS_ENSURE_ARG_POINTER(aCookieContainer);
+    return NS_OK;
+}
+
Index: docshell/base/nsDocShell.h
===================================================================
RCS file: /cvsroot/mozilla/docshell/base/nsDocShell.h,v
retrieving revision 1.211
diff -p -U 8 -r1.211 nsDocShell.h
--- docshell/base/nsDocShell.h	6 May 2007 21:06:27 -0000	1.211
+++ docshell/base/nsDocShell.h	14 May 2007 09:22:21 -0000
@@ -100,16 +100,18 @@
 #include "nsIWebBrowserFind.h"
 #include "nsIHttpChannel.h"
 #include "nsDocShellTransferableHooks.h"
 #include "nsIAuthPromptProvider.h"
 #include "nsISecureBrowserUI.h"
 #include "nsIObserver.h"
 #include "nsDocShellLoadTypes.h"
 #include "nsPIDOMEventTarget.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 class nsIScrollableView;
 
 /* load commands were moved to nsIDocShell.h */
 /* load types were moved to nsDocShellLoadTypes.h */
 
 /* internally used ViewMode types */
 enum ViewMode {
@@ -156,17 +158,18 @@ class nsDocShell : public nsDocLoader,
                    public nsIDocCharset, 
                    public nsIContentViewerContainer,
                    public nsIScriptGlobalObjectOwner,
                    public nsIRefreshURI,
                    public nsIWebProgressListener,
                    public nsIEditorDocShell,
                    public nsIWebPageDescriptor,
                    public nsIAuthPromptProvider,
-                   public nsIObserver
+                   public nsIObserver,
+                   public nsICookieCollector
 {
 friend class nsDSURIContentListener;
 
 public:
     // Object Management
     nsDocShell();
 
     virtual nsresult Init();
@@ -185,16 +188,17 @@ public:
     NS_DECL_NSIINTERFACEREQUESTOR
     NS_DECL_NSIWEBPROGRESSLISTENER
     NS_DECL_NSIREFRESHURI
     NS_DECL_NSICONTENTVIEWERCONTAINER
     NS_DECL_NSIEDITORDOCSHELL
     NS_DECL_NSIWEBPAGEDESCRIPTOR
     NS_DECL_NSIAUTHPROMPTPROVIDER
     NS_DECL_NSIOBSERVER
+    NS_DECL_NSICOOKIECOLLECTOR
 
     NS_IMETHOD Stop() {
         // Need this here because otherwise nsIWebNavigation::Stop
         // overrides the docloader's Stop()
         return nsDocLoader::Stop();
     }
 
     // Need to implement (and forward) nsISecurityEventSink, because
@@ -594,16 +598,18 @@ protected:
     nsDocShellEditorData*      mEditorData;          // editor data, if any
 
     // Transferable hooks/callbacks
     nsCOMPtr<nsIClipboardDragDropHookList>  mTransferableHookData;
 
     // Secure browser UI object
     nsCOMPtr<nsISecureBrowserUI> mSecurityUI;
 
+    nsCOMPtr<nsICookieContainer> mCookieContainer;
+
     // WEAK REFERENCES BELOW HERE.
     // Note these are intentionally not addrefd.  Doing so will create a cycle.
     // For that reasons don't use nsCOMPtr.
 
     nsIDocShellTreeOwner *     mTreeOwner; // Weak Reference
     nsPIDOMEventTarget *       mChromeEventHandler; //Weak Reference
 
     static nsIURIFixup *sURIFixup;
Index: docshell/base/nsWebShell.cpp
===================================================================
RCS file: /cvsroot/mozilla/docshell/base/nsWebShell.cpp,v
retrieving revision 1.684
diff -p -U 8 -r1.684 nsWebShell.cpp
--- docshell/base/nsWebShell.cpp	18 Feb 2007 04:24:05 -0000	1.684
+++ docshell/base/nsWebShell.cpp	14 May 2007 09:22:24 -0000
@@ -108,16 +108,19 @@
 #include "nsILocaleService.h"
 #include "nsIStringBundle.h"
 
 #include "nsICachingChannel.h"
 
 #include "nsIDocument.h"
 #include "nsITextToSubURI.h"
 
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
+
 #include "nsIExternalProtocolService.h"
 #include "nsCExternalHandlerService.h"
 
 #include "nsIIDNService.h"
 
 #include "nsIPrefBranch.h"
 #include "nsIPrefService.h"
 #include "nsITimer.h"
@@ -439,16 +442,25 @@ SendPing(void *closure, nsIContent *cont
   if (!httpChan)
     return;
 
   // This is needed in order for 3rd-party cookie blocking to work.
   nsCOMPtr<nsIHttpChannelInternal> httpInternal = do_QueryInterface(httpChan);
   if (httpInternal)
     httpInternal->SetDocumentURI(doc->GetDocumentURI());
 
+  // set the cookie container of the channel to that of the doc's
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(chan));
+  if (cookieCollector) {
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    nsCOMPtr<nsICookieCollector> parentCollector = do_GetInterface(doc);
+    parentCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
+    cookieCollector->SetCookieContainer(cookieContainer);
+  }
+
   if (info->referrer)
     httpChan->SetReferrer(info->referrer);
 
   httpChan->SetRequestMethod(NS_LITERAL_CSTRING("POST"));
 
   // Remove extraneous request headers (to reduce request size)
   httpChan->SetRequestHeader(NS_LITERAL_CSTRING("accept"),
                              EmptyCString(), PR_FALSE);
Index: dom/src/base/nsGlobalWindow.cpp
===================================================================
RCS file: /cvsroot/mozilla/dom/src/base/nsGlobalWindow.cpp,v
retrieving revision 1.932
diff -p -U 8 -r1.932 nsGlobalWindow.cpp
--- dom/src/base/nsGlobalWindow.cpp	11 May 2007 13:34:08 -0000	1.932
+++ dom/src/base/nsGlobalWindow.cpp	14 May 2007 09:22:40 -0000
@@ -151,16 +151,18 @@
 #include "nsAutoPtr.h"
 #include "nsContentUtils.h"
 #include "nsCSSProps.h"
 #include "nsIURIFixup.h"
 #include "nsCDefaultURIFixup.h"
 #include "nsEventDispatcher.h"
 #include "nsIObserverService.h"
 #include "nsNetUtil.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 #include "plbase64.h"
 
 #ifdef NS_PRINTING
 #include "nsIPrintSettings.h"
 #include "nsIPrintSettingsService.h"
 #include "nsIWebBrowserPrint.h"
 #endif
Index: embedding/components/windowwatcher/src/nsWindowWatcher.cpp
===================================================================
RCS file: /cvsroot/mozilla/embedding/components/windowwatcher/src/nsWindowWatcher.cpp,v
retrieving revision 1.129
diff -p -U 8 -r1.129 nsWindowWatcher.cpp
--- embedding/components/windowwatcher/src/nsWindowWatcher.cpp	24 Oct 2006 21:42:18 -0000	1.129
+++ embedding/components/windowwatcher/src/nsWindowWatcher.cpp	14 May 2007 09:22:57 -0000
@@ -78,16 +78,18 @@
 #include "nsIXPConnect.h"
 #include "nsPIDOMWindow.h"
 #include "nsIMarkupDocumentViewer.h"
 #include "nsIContentViewer.h"
 #include "nsIDocumentViewer.h"
 #include "nsIWindowProvider.h"
 #include "nsIMutableArray.h"
 #include "nsISupportsArray.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 #include "nsIPrefBranch.h"
 #include "nsIPrefService.h"
 
 #include "jsinterp.h" // for js_AllocStack() and js_FreeStack()
 
 #ifdef USEWEAKREFS
 #include "nsIWeakReference.h"
@@ -825,16 +827,26 @@ nsWindowWatcher::OpenWindowJSInternal(ns
 #ifdef DEBUG
     nsCOMPtr<nsPIDOMWindow> newDebugWindow = do_GetInterface(newDocShell);
     NS_ASSERTION(newWindow == newDebugWindow, "Different windows??");
 #endif
     if (newWindow) {
       newWindow->SetOpenerScriptPrincipal(newWindowPrincipal);
     }
   }
+  
+  // new docShell inherits cookie container from old docShell
+  if (newDocShell && aParent) {
+    nsCOMPtr<nsPIDOMWindow> parent = do_QueryInterface(aParent);
+    nsCOMPtr<nsICookieCollector> parentCollector = do_QueryInterface(parent->GetDocShell());
+    nsCOMPtr<nsICookieContainer> container; 
+    parentCollector->GetCookieContainer(getter_AddRefs(container));
+    nsCOMPtr<nsICookieCollector> collector = do_QueryInterface(newDocShell);
+    collector->SetCookieContainer(container);
+  }
 
   if (uriToLoad) { // get the script principal and pass it to docshell
     JSContextAutoPopper contextGuard;
 
     cx = GetJSContextFromCallStack();
 
     // get the security manager
     if (!cx)
Index: layout/style/nsCSSLoader.cpp
===================================================================
RCS file: /cvsroot/mozilla/layout/style/nsCSSLoader.cpp,v
retrieving revision 3.227
diff -p -U 8 -r3.227 nsCSSLoader.cpp
--- layout/style/nsCSSLoader.cpp	3 May 2007 01:15:53 -0000	3.227
+++ layout/style/nsCSSLoader.cpp	14 May 2007 09:23:41 -0000
@@ -74,16 +74,18 @@
 #include "nsICSSStyleSheet.h"
 #include "nsIStyleSheetLinkingElement.h"
 #include "nsICSSLoaderObserver.h"
 #include "nsICSSLoader.h"
 #include "nsICSSParser.h"
 #include "nsICSSImportRule.h"
 #include "nsThreadUtils.h"
 #include "nsGkAtoms.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 #ifdef MOZ_XUL
 #include "nsXULPrototypeCache.h"
 #endif
 
 #include "nsIMediaList.h"
 #include "nsIDOMStyleSheet.h"
 #include "nsIDOMCSSStyleSheet.h"
@@ -1424,16 +1426,22 @@ CSSLoaderImpl::LoadSheet(SheetLoadData* 
     // send a minimal Accept header for text/css
     httpChannel->SetRequestHeader(NS_LITERAL_CSTRING("Accept"),
                                   NS_LITERAL_CSTRING("text/css,*/*;q=0.1"),
                                   PR_FALSE);
     nsCOMPtr<nsIURI> referrerURI = aLoadData->GetReferrerURI();
     if (referrerURI)
       httpChannel->SetReferrer(referrerURI);
   }
+  // set the cookie container of the channel to that of the doc's
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(channel));
+  if (cookieCollector) {
+    nsCOMPtr<nsICookieContainer> container(do_GetInterface(mDocument));
+    cookieCollector->SetCookieContainer(container);
+  }
 
   // Now tell the channel we expect text/css data back....  We do
   // this before opening it, so it's only treated as a hint.
   channel->SetContentType(NS_LITERAL_CSTRING("text/css"));
 
   if (aLoadData->mLoaderPrincipal) {
     PRBool inherit;
     rv = NS_URIChainHasFlags(aLoadData->mURI,
Index: modules/libpr0n/src/imgLoader.cpp
===================================================================
RCS file: /cvsroot/mozilla/modules/libpr0n/src/imgLoader.cpp,v
retrieving revision 1.93
diff -p -U 8 -r1.93 imgLoader.cpp
--- modules/libpr0n/src/imgLoader.cpp	1 Jun 2006 18:35:20 -0000	1.93
+++ modules/libpr0n/src/imgLoader.cpp	14 May 2007 09:23:45 -0000
@@ -56,16 +56,20 @@
 #include "imgRequest.h"
 #include "imgRequestProxy.h"
 
 #include "ImageErrors.h"
 #include "ImageLogging.h"
 
 #include "nsIComponentRegistrar.h"
 
+// required for cookie container
+#include "nsICookieContainer.h"
+#include "nsICookieCollector.h"
+
 // we want to explore making the document own the load group
 // so we can associate the document URI with the load group.
 // until this point, we have an evil hack:
 #include "nsIHttpChannelInternal.h"  
 
 #if defined(DEBUG_pavlov) || defined(DEBUG_timeless)
 #include "nsISimpleEnumerator.h"
 #include "nsXPCOM.h"
@@ -172,17 +176,18 @@ static PRBool RevalidateEntry(nsICacheEn
 }
 
 
 static nsresult NewImageChannel(nsIChannel **aResult,
                                 nsIURI *aURI,
                                 nsIURI *aInitialDocumentURI,
                                 nsIURI *aReferringURI,
                                 nsILoadGroup *aLoadGroup,
-                                nsLoadFlags aLoadFlags)
+                                nsLoadFlags aLoadFlags,
+                                nsICookieContainer *aCookieContainer)
 {
   nsresult rv;
   nsCOMPtr<nsIChannel> newChannel;
   nsCOMPtr<nsIHttpChannel> newHttpChannel;
  
   nsCOMPtr<nsIInterfaceRequestor> callbacks;
 
   if (aLoadGroup) {
@@ -218,16 +223,20 @@ static nsresult NewImageChannel(nsIChann
                                      NS_LITERAL_CSTRING("image/png,*/*;q=0.5"),
                                      PR_FALSE);
 
     nsCOMPtr<nsIHttpChannelInternal> httpChannelInternal = do_QueryInterface(newHttpChannel);
     NS_ENSURE_TRUE(httpChannelInternal, NS_ERROR_UNEXPECTED);
     httpChannelInternal->SetDocumentURI(aInitialDocumentURI);
     newHttpChannel->SetReferrer(aReferringURI);
   }
+  nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryInterface(*aResult);
+  if (cookieCollector) {
+    cookieCollector->SetCookieContainer(aCookieContainer);
+  }
 
   // Image channels are loaded by default with reduced priority.
   nsCOMPtr<nsISupportsPriority> p = do_QueryInterface(*aResult);
   if (p) {
     PRUint32 priority = nsISupportsPriority::PRIORITY_LOW;
 
     if (aLoadFlags & nsIRequest::LOAD_BACKGROUND)
       ++priority; // further reduce priority for background loads
@@ -375,16 +384,23 @@ NS_IMETHODIMP imgLoader::LoadImage(nsIUR
             "imgRequest [request=%p]\n", this, request));
 
     entry = nsnull;
     NS_RELEASE(request);
 
     bCanCacheRequest = PR_FALSE;
   }
 
+  // find the document's cookie container
+  nsCOMPtr<nsICookieContainer> cookieContainer = nsnull;
+  if (aCX) {
+    // aCX is nsIDocument
+    cookieContainer = do_GetInterface(aCX);
+  }
+
   //
   // Time to load the request... There are 3 possible cases:
   // =======================================================
   //   1. There is no cached request (ie. nothing was found in the cache).
   //
   //   2. There is a cached request that must be validated.
   //
   //   3. There is a valid cached request.
@@ -409,17 +425,18 @@ NS_IMETHODIMP imgLoader::LoadImage(nsIUR
 
     } else {
       nsCOMPtr<nsIChannel> newChannel;
       rv = NewImageChannel(getter_AddRefs(newChannel),
                            aURI,
                            aInitialDocumentURI,
                            aReferrerURI,
                            aLoadGroup,
-                           requestFlags);
+                           requestFlags,
+                           cookieContainer);
       if (NS_FAILED(rv)) {
         NS_RELEASE(request);
         return NS_ERROR_FAILURE;
       }
 
       nsCOMPtr<nsICachingChannel> cacheChan(do_QueryInterface(newChannel));
 
       if (cacheChan) {
@@ -465,17 +482,18 @@ NS_IMETHODIMP imgLoader::LoadImage(nsIUR
     LOG_SCOPE(gImgLog, "imgLoader::LoadImage |cache miss|");
 
     nsCOMPtr<nsIChannel> newChannel;
     rv = NewImageChannel(getter_AddRefs(newChannel),
                          aURI,
                          aInitialDocumentURI,
                          aReferrerURI,
                          aLoadGroup,
-                         requestFlags);
+                         requestFlags,
+                         cookieContainer);
     if (NS_FAILED(rv))
       return NS_ERROR_FAILURE;
 
     NS_NEWXPCOM(request, imgRequest);
     if (!request) return NS_ERROR_OUT_OF_MEMORY;
 
     NS_ADDREF(request);
 
Index: modules/plugin/base/src/nsPluginHostImpl.cpp
===================================================================
RCS file: /cvsroot/mozilla/modules/plugin/base/src/nsPluginHostImpl.cpp,v
retrieving revision 1.572
diff -p -U 8 -r1.572 nsPluginHostImpl.cpp
--- modules/plugin/base/src/nsPluginHostImpl.cpp	1 May 2007 22:24:24 -0000	1.572
+++ modules/plugin/base/src/nsPluginHostImpl.cpp	14 May 2007 09:24:03 -0000
@@ -168,16 +168,19 @@
 #include "nsISupportsArray.h"
 #include "nsIDocShell.h"
 #include "nsPluginNativeWindow.h"
 #include "nsIScriptSecurityManager.h"
 #include "nsIContentPolicy.h"
 #include "nsContentPolicyUtils.h"
 #include "nsContentErrors.h"
 
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
+
 #ifdef XP_UNIX
 #if defined (MOZ_WIDGET_GTK2)
 #include <gdk/gdkx.h> // for GDK_DISPLAY()
 #elif defined(MOZ_WIDGET_QT)
 #include <qwindowdefs.h> // for qt_xdisplay()
 #endif
 #endif
 
@@ -6190,17 +6193,21 @@ NS_IMETHODIMP nsPluginHostImpl::GetCooki
   }
 
   // make an nsURI from the argument url
   rv = ioService->NewURI(nsDependentCString(inCookieURL), nsnull, nsnull, getter_AddRefs(uriIn));
   if (NS_FAILED(rv)) {
     return rv;
   }
 
-  rv = cookieService->GetCookieString(uriIn, nsnull, getter_Copies(cookieString));
+  // get the default cookie container
+  nsCOMPtr<nsICookieContainer> container;
+  cookieService->GetDefaultContainer(getter_AddRefs(container));
+
+  rv = cookieService->GetCookieString(container, uriIn, nsnull, getter_Copies(cookieString));
 
   if (NS_FAILED(rv) || (!cookieString) ||
       (inOutCookieSize <= (cookieStringLen = PL_strlen(cookieString.get())))) {
     return NS_ERROR_FAILURE;
   }
 
   PL_strcpy((char *) inOutCookieBuffer, cookieString.get());
   inOutCookieSize = cookieStringLen;
@@ -6234,24 +6241,28 @@ NS_IMETHODIMP nsPluginHostImpl::SetCooki
     return NS_ERROR_FAILURE;
   }
 
   // make an nsURI from the argument url
   rv = ioService->NewURI(nsDependentCString(inCookieURL), nsnull, nsnull, getter_AddRefs(uriIn));
   if (NS_FAILED(rv)) {
     return NS_ERROR_FAILURE;
   }
+  
+  // get the default cookie container
+  nsCOMPtr<nsICookieContainer> container;
+  cookieService->GetDefaultContainer(getter_AddRefs(container));
 
   nsCOMPtr<nsIPrompt> prompt;
   GetPrompt(nsnull, getter_AddRefs(prompt));
 
   char * cookie = (char *)inCookieBuffer;
   char c = cookie[inCookieSize];
   cookie[inCookieSize] = '\0';
-  rv = cookieService->SetCookieString(uriIn, prompt, cookie, nsnull);
+  rv = cookieService->SetCookieString(container, uriIn, prompt, cookie, nsnull);
   cookie[inCookieSize] = c;
 
   return rv;
 }
 
 
 ////////////////////////////////////////////////////////////////////////
 NS_IMETHODIMP nsPluginHostImpl::Observe(nsISupports *aSubject,
Index: netwerk/build/nsNetCID.h
===================================================================
RCS file: /cvsroot/mozilla/netwerk/build/nsNetCID.h,v
retrieving revision 1.65
diff -p -U 8 -r1.65 nsNetCID.h
--- netwerk/build/nsNetCID.h	17 Feb 2007 03:47:27 -0000	1.65
+++ netwerk/build/nsNetCID.h	14 May 2007 09:24:07 -0000
@@ -748,16 +748,29 @@
 #define NS_COOKIESERVICE_CID                           \
 { /* c375fa80-150f-11d6-a618-0010a401eb10 */           \
     0xc375fa80,                                        \
     0x150f,                                            \
     0x11d6,                                            \
     { 0xa6, 0x18, 0x00, 0x10, 0xa4, 0x01, 0xeb, 0x10 } \
 }
 
+// the cookie container
+#define NS_COOKIECONTAINER_CLASSNAME \
+    "CookieContainer"
+#define NS_COOKIECONTAINER_CONTRACTID \
+    "@mozilla.org/cookie-container;1"
+#define NS_COOKIECONTAINER_CID                         \
+{ /* f3a95abb-65f8-4203-acdb-3f309752433a */           \
+    0xf3a95abb,                                        \
+    0x65f8,                                            \
+    0x4203,                                            \
+    { 0xac, 0xdb, 0x3f, 0x30, 0x97, 0x52, 0x43, 0x3a } \
+}
+
 /******************************************************************************
  * netwerk/streamconv classes
  */
 
 // service implementing nsIStreamConverterService
 #define NS_STREAMCONVERTERSERVICE_CONTRACTID \
     "@mozilla.org/streamConverters;1"
 #define NS_STREAMCONVERTERSERVICE_CID                \
Index: netwerk/build/nsNetModule.cpp
===================================================================
RCS file: /cvsroot/mozilla/netwerk/build/nsNetModule.cpp,v
retrieving revision 1.140
diff -p -U 8 -r1.140 nsNetModule.cpp
--- netwerk/build/nsNetModule.cpp	15 Nov 2006 21:38:47 -0000	1.140
+++ netwerk/build/nsNetModule.cpp	14 May 2007 09:24:10 -0000
@@ -157,17 +157,19 @@ NS_GENERIC_FACTORY_CONSTRUCTOR(nsDirInde
 
 #include "nsStreamListenerTee.h"
 NS_GENERIC_FACTORY_CONSTRUCTOR(nsStreamListenerTee)
 
 ///////////////////////////////////////////////////////////////////////////////
 
 #ifdef NECKO_COOKIES
 #include "nsCookieService.h"
+#include "nsCookieContainer.h"
 NS_GENERIC_FACTORY_SINGLETON_CONSTRUCTOR(nsCookieService, nsCookieService::GetSingleton)
+NS_GENERIC_FACTORY_CONSTRUCTOR(nsCookieContainer)
 #endif
 
 ///////////////////////////////////////////////////////////////////////////////
 // protocols
 ///////////////////////////////////////////////////////////////////////////////
 
 // about:blank is mandatory
 #include "nsAboutProtocolHandler.h"
@@ -1029,24 +1031,30 @@ static const nsModuleComponentInfo gNetM
        NS_CACHESERVICE_CONTRACTID,
        nsCacheService::Create
     },
 
 #ifdef NECKO_COOKIES
     { NS_COOKIEMANAGER_CLASSNAME,
       NS_COOKIEMANAGER_CID,
       NS_COOKIEMANAGER_CONTRACTID,
-      nsCookieServiceConstructor
+      nsCookieService::GetDefaultContainer
     },
 
     { NS_COOKIESERVICE_CLASSNAME,
       NS_COOKIESERVICE_CID,
       NS_COOKIESERVICE_CONTRACTID,
       nsCookieServiceConstructor
     },
+
+    { NS_COOKIECONTAINER_CLASSNAME,
+      NS_COOKIECONTAINER_CID,
+      NS_COOKIECONTAINER_CONTRACTID,
+      nsCookieContainerConstructor
+    },
 #endif
 
 #ifdef NECKO_PROTOCOL_gopher
     //gopher:
     { "The Gopher Protocol Handler", 
       NS_GOPHERHANDLER_CID,
       NS_NETWORK_PROTOCOL_CONTRACTID_PREFIX "gopher",
       nsGopherHandlerConstructor
Index: netwerk/cookie/public/nsICookieCollector.idl
===================================================================
RCS file: netwerk/cookie/public/nsICookieCollector.idl
diff -N netwerk/cookie/public/nsICookieCollector.idl
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ netwerk/cookie/public/nsICookieCollector.idl	14 May 2007 09:24:10 -0000
@@ -0,0 +1,50 @@
+/* ***** BEGIN LICENSE BLOCK *****
+ * Version: MPL 1.1/GPL 2.0/LGPL 2.1
+ *
+ * The contents of this file are subject to the Mozilla Public License Version
+ * 1.1 (the "License"); you may not use this file except in compliance with
+ * the License. You may obtain a copy of the License at
+ * http://www.mozilla.org/MPL/
+ *
+ * Software distributed under the License is distributed on an "AS IS" basis,
+ * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
+ * for the specific language governing rights and limitations under the
+ * License.
+ *
+ * The Original Code is the Cookie Containers Code.
+ *
+ * The Initial Developer of the Original Code is
+ * Loune Lam <lpgcritter at nasquan dot com>.
+ *
+ * Portions created by the Initial Developer are Copyright (C) 2007
+ * the Initial Developer. All Rights Reserved.
+ *
+ * Contributor(s):
+ *   Loune Lam <lpgcritter at nasquan dot com>
+ *
+ * Alternatively, the contents of this file may be used under the terms of
+ * either the GNU General Public License Version 2 or later (the "GPL"), or
+ * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
+ * in which case the provisions of the GPL or the LGPL are applicable instead
+ * of those above. If you wish to allow use of your version of this file only
+ * under the terms of either the GPL or the LGPL, and not to allow others to
+ * use your version of this file under the terms of the MPL, indicate your
+ * decision by deleting the provisions above and replace them with the notice
+ * and other provisions required by the GPL or the LGPL. If you do not delete
+ * the provisions above, a recipient may use your version of this file under
+ * the terms of any one of the MPL, the GPL or the LGPL.
+ *
+ * ***** END LICENSE BLOCK ***** */
+
+#include "nsISupports.idl"
+
+interface nsICookieContainer;
+
+[scriptable, uuid(95D62733-7B16-42db-B795-FE385F44930A)]
+interface nsICookieCollector : nsISupports
+{
+	/**
+	 * The container this cookie collector holds
+	 */
+	attribute nsICookieContainer cookieContainer;
+};
